//+------------------------------------------------------------------+
//|                                         podborinduka.mq4 |
//+------------------------------------------------------------------+

#property indicator_separate_window
//#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Gold
#property indicator_width1 2
#property indicator_level1 0.0

//   
extern int X1 = 129;
extern int X2 = 101;
extern int X3 = 88;
extern int X4 = 30;
extern int X5 = 16;
extern int X6  = 95;
extern int X7  = 56;
extern int X8  = 79;
extern int X9  = 96;
extern int X10 = 48;
extern int X11 = 50;
extern int X12 = 50;
extern int X13 = 50;
extern int X14 = 50;

//---- indicator buffers
double            Buffer[];
//   
int   i;
int Isobr = 400, Sdvig = 140;
//  
#define SliderPrefix "SL_"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(1);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION);
//---- indicator buffers mapping
   SetIndexBuffer(0,Buffer);
   SetIndexEmptyValue(0,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    ClearSliders(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

  //
  //  ( )     
  X1  = ParamValue(0, SliderPrefix+"X1", X1, 1, 201, Blue);
  X2  = ParamValue(1, SliderPrefix+"X2", X2, 1, 201, Red);
  X3  = ParamValue(2, SliderPrefix+"X3", X3, 1, 201, Gold);
  X4  = ParamValue(3, SliderPrefix+"X4", X4, 1, 201, Chartreuse);
  X5  = ParamValue(4, SliderPrefix+"X5", X5, 1, 201, Aqua);
  X6  = ParamValue(5, SliderPrefix+"X6", X6, 1, 201, DarkViolet);
  X7  = ParamValue(6, SliderPrefix+"X7", X7, 1, 201, FireBrick);
  X8  = ParamValue(7, SliderPrefix+"X8", X8, 1, 201, MediumVioletRed);
  X9  = ParamValue(8, SliderPrefix+"X9", X9, 1, 201, MediumSeaGreen);
  X10  = ParamValue(9, SliderPrefix+"X10", X10, 1, 201, Chocolate);
  X11  = ParamValue(10, SliderPrefix+"X11", X11, 1, 201, Crimson);
  X12  = ParamValue(11, SliderPrefix+"X12", X12, 1, 201, SteelBlue);
  X13  = ParamValue(12, SliderPrefix+"X13", X13, 1, 201, Goldenrod);
  X14  = ParamValue(13, SliderPrefix+"X14", X14, 1, 201, MediumSpringGreen);
//  X  = ParamValue(, SliderPrefix+"X", X, 1, 201, );
  //


 //           
     for(i=Isobr;i>0;i--)
            {
//                 Buffer[i] = iMA(NULL,0,PeriodMA,0,MA_Method,PRICE_CLOSE,i);
               Buffer[i] =iCustom(NULL,0,"iNNN_v3",X1,X2,X3,X4,X5,X6,X7,X8,X9,X10,X11,X12,X13,X14,0,i);
            }
//Comment ("PeriodMA = ",PeriodMA,", MA_Method = ",MA_Method,", SignalSMA = ",SignalSMA);
Labl(20,20,"A_","X1="+DoubleToStr(X1,0)+", X2="+DoubleToStr(X2,0)+", X3="+DoubleToStr(X3,0)+", X4="+DoubleToStr(X4,0)+", X5="+DoubleToStr(X5,0)+", X6="+DoubleToStr(X6,0)+", X7="+DoubleToStr(X7,0)+",");        
Labl(20,40,"B_","X8="+DoubleToStr(X8,0)+", X9="+DoubleToStr(X9,0)+", X10="+DoubleToStr(X10,0)+", X11="+DoubleToStr(X11,0)+", X12="+DoubleToStr(X12,0)+", X13="+DoubleToStr(X13,0)+", X14="+DoubleToStr(X14,0));       
//----
   return(0);
  }

//+------------------------------------------------------------------+
//  
//
double ParamValue(int ParamNo, string ParamName, double ParamValue, double vMin, double vMax, color clr)
{
  double Triangle[3],vCur, WMax, WMin; datetime tt1, tt2; 

  //    -  
  if(ObjectFind(ParamName) < 0)
  {
    //        
    WMax = High[iHighest(NULL,0,MODE_HIGH,Sdvig,1)]+(Point*4);  
    WMin = Low[iLowest(NULL,0,MODE_LOW,Sdvig,1)]-(Point*4);
   
    //     ...
    tt1 = Time[Sdvig] + Period()*60*ParamNo*10; 
    tt2 = tt1 + Period()*60*10;
    // ...  ""
    vCur = WMin + (ParamValue - vMin) * (WMax - WMin) / (vMax - vMin);
    //          
    ObjectCreate(ParamName,OBJ_TRIANGLE, 0, tt1,WMax, tt2,vCur, tt1,WMin);
    ObjectSet(ParamName,OBJPROP_COLOR,clr);
  }
  //   -   
  Triangle[0] = ObjectGet(ParamName,OBJPROP_PRICE1);
  Triangle[1] = ObjectGet(ParamName,OBJPROP_PRICE2);
  Triangle[2] = ObjectGet(ParamName,OBJPROP_PRICE3);
  //      "
  ArraySort(Triangle);
  //          vMin  vMax
  vCur = vMin + (Triangle[1] - Triangle[0]) / (Triangle[2] - Triangle[0]) * (vMax - vMin);
  //     
  ObjectSetText(ParamName,DoubleToStr(vCur,2)); 
  //     
  return(vCur); 
}
//+------------------------------------------------------------------+
//     
void ClearSliders() 
{ 
  for(int i=ObjectsTotal()-1;i>=0;i--) if(StringFind(ObjectName(i),SliderPrefix)==0) ObjectDelete(ObjectName(i)); 
}
//
//==================================================================//
void Labl(int XDIST,int YDIST,string Index,string N){
   //----  HA  ----//
   string Nlabel = SliderPrefix+Index;
   
   ObjectDelete(Nlabel);
   ObjectCreate(Nlabel,OBJ_LABEL,0,0,0);
   ObjectSet(Nlabel,OBJPROP_CORNER,0);
   ObjectSet(Nlabel,OBJPROP_COLOR,Aqua);
   ObjectSet(Nlabel, OBJPROP_XDISTANCE, XDIST);
   ObjectSet(Nlabel, OBJPROP_YDISTANCE, YDIST);
   ObjectSetText(Nlabel,N,14,"Arial",Aqua);
   }
//==================================================================//


